package a1_solutionUsingReflection;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Image;
import java.awt.Point;
import java.awt.font.TextAttribute;
import java.text.AttributedString;
import java.util.*;

/**
 * This class encapsulates the data model for the A1 assignment: (1) the image,
 * (2) the visual masses (incl. where are they located within the image, in what
 * manner are they outlined, etc), and (3) the text.
 * 
 * This implementation of this model is somewhat inconsistent in that the image
 * parameter is passed to the constructor, but the remainder of the attributes
 * are hard-coded internally. This design should be improved.
 * 
 * @author mb
 * 
 */
public class A1ModelVariant2 {

	private List<VisualMass> theShapes;
	private Image img;
	private static final Hashtable<TextAttribute, Object> map = new Hashtable<TextAttribute, Object>();
	static {
		map.put(TextAttribute.FAMILY, "Serif");
		map.put(TextAttribute.SIZE, new Float(18.0));
	}

	private static AttributedString theText = new AttributedString(
			"What kind of New Age sort of image is this? "
					+ "Is it supposed to represent empowerment or "
					+ "is it instead supposed to be a metaphorical represent this figure supporting "
					+ "the weight of a swirl of contradicting opinion? ", map);

	public A1ModelVariant2(String locationOfImageRelativeToWorkingDirectory) {
		String fileLocation = System.getProperty("user.dir")
				+ locationOfImageRelativeToWorkingDirectory;
		img = A1Utilities.getImageFromFile(fileLocation);

		theShapes = new Vector<VisualMass>();
		double balloonRelHeight = 55 / 100.;
		double balloonRelWidth = 55 / 100.;
		double FRAC_X = 50 / 100.;
		double FRAC_Y = 39 / 100.;

		VisualMass vm1 = new VisualMass(FRAC_X, FRAC_Y, balloonRelWidth,
				balloonRelHeight);
		vm1.setColour(Color.RED);

		vm1.setTheShapeConstructor("java.awt.geom.Ellipse2D$Float");
		Class<?>[] paramsForEllipse = { Float.TYPE, Float.TYPE, Float.TYPE,
				Float.TYPE };
		vm1.setTheShapeConstructorParameterList(paramsForEllipse);
		vm1.setConstructorParameterHelper(new ShapeConstructorHelper(vm1) {
			@Override
			/**
			 * these are the args that are used in order to instantiate the 
			 * constructor whose signature is jointly specified 
			 * by setTheShapeConstructor(String) and by 
			 * setTheShapeConstructorParameterList(Class<?>[])
			 */
			public Object[] getConstructorArgs(Dimension size) {
				// this are the args that are used when invoking the
				// Ellipse2D$Float constructor with the signature specified for
				// the passed VisualMass object
				Point centre = getVisualMass().getCentreOfVisualMass(size);
				int width = (int) Math.floor(size.width
						* getVisualMass().getWidthRelativeToImage());
				int height = (int) Math.floor(size.height
						* getVisualMass().getHeightRelativeToImage());
				Point anchor = new Point(centre.x - width / 2, centre.y
						- height / 2);
				Object[] args = { anchor.x, anchor.y, width, height };
				return args;
			}
		});
		theShapes.add(vm1);

		double girlRelWidth = 12 / 100.;
		double girlRelHeight = 23 / 100.;
		double FRAC_X2 = 50 / 100.;
		double FRAC_Y2 = 77 / 100.;
		VisualMass vm2 = new VisualMass(FRAC_X2, FRAC_Y2, girlRelWidth,
				girlRelHeight);
		vm2.setColour(Color.BLUE);
		vm2.setTheShapeConstructor("java.awt.geom.RoundRectangle2D$Float");
		Class<?>[] paramsForRoundRectangle = { Float.TYPE, Float.TYPE,
				Float.TYPE, Float.TYPE, Float.TYPE, Float.TYPE };
		vm2.setTheShapeConstructorParameterList(paramsForRoundRectangle);
		vm2.setConstructorParameterHelper(new ShapeConstructorHelper(vm2) {
			@Override
			/**
			 * these are the args that are used in order to instantiate the 
			 * constructor whose signature is jointly specified 
			 * by setTheShapeConstructor(String) and by 
			 * setTheShapeConstructorParameterList(Class<?>[])
			 */
			public Object[] getConstructorArgs(Dimension size) {
				//
				Point centre = getVisualMass().getCentreOfVisualMass(size);
				int width = (int) Math.floor(size.width
						* getVisualMass().getWidthRelativeToImage());
				int height = (int) Math.floor(size.height
						* getVisualMass().getHeightRelativeToImage());
				Point anchor = new Point(centre.x - width / 2, centre.y
						- height / 2);
				final int ARC_WIDTH = 3;
				final int ARC_HEIGHT = 3;
				Object[] args = { anchor.x, anchor.y, width, height, ARC_WIDTH,
						ARC_HEIGHT };
				return args;
			}
		});
		theShapes.add(vm2);
	}

	public Image getImage() {
		return img;
	}

	public AttributedString getTheText() {
		return theText;
	}

	public List<VisualMass> getShapes() {
		return theShapes;
	}

}
