package labtest1_solution;

import java.awt.Image;
import java.io.File;
import java.io.IOException;
import javax.imageio.ImageIO;

/**
 * This class encapsulates utility calculations that are specific to a
 * particular image.
 * 
 * @author mb
 * 
 */
public class A1Utilities {

	/**
	 * This method returns a Image as derived from the file at the
	 * passedLocation
	 * 
	 * @return
	 */
	public static Image getImageFromFile(String fileLocation) {
		Image img = null;
		File file = new File(fileLocation);
		try {
			img = ImageIO.read(file);
		} catch (IOException e) {
			throw new RuntimeException("Could not read/find file at location: "
					+ fileLocation, e);
		}
		return img;
	}

}
